using Library;
using MySystem.Models;
using System;
using System.Linq;

namespace MySystem
{
    public class MsgPlacardReadHelper
    {
        public readonly static MsgPlacardReadHelper Instance = new MsgPlacardReadHelper();
        private MsgPlacardReadHelper()
        { }

        public string Start()
        {
            bool op = true;
            WebCMSEntities db = new WebCMSEntities();
            string result = "";
            int total = 0;
            while (op)
            {
                MsgPlacardRead PopData = new MsgPlacardRead();
                try
                {
                    //获取apserver待同步的数据，执行入库
                    PopData = RedisDbconn.Instance.RPop<MsgPlacardRead>("Pop:MsgPlacardRead");
                    if (PopData != null)
                    {
                        MsgPlacardRead checkExist = db.MsgPlacardRead.FirstOrDefault(m => m.Id == PopData.Id);
                        if (checkExist != null)
                        {
                            checkExist = PopData;
                        }
                        else
                        {
                            db.MsgPlacardRead.Add(PopData);
                        }
                        if (total >= 20)
                        {
                            total = 0;
                            db.SaveChanges();
                        }
                        if (string.IsNullOrEmpty(result)) result = "success";
                    }
                    else
                    {
                        db.SaveChanges();
                        op = false;
                    }
                }
                catch (Exception ex)
                {
                    ErrorMsg msg = new ErrorMsg();
                    msg.Obj = PopData;
                    msg.Time = DateTime.Now;
                    msg.ErrorContent = ex.ToString();
                    function.WriteLog(Newtonsoft.Json.JsonConvert.SerializeObject(msg), "Pop:MsgPlacardRead:Error");
                    result = "有异常，请查看Pop:MsgPlacardRead:Error队列";
                }
            }
            db.Dispose();
            return result;
        }
    }
}